import std/[strutils, terminal]


proc merge[T](s: var openArray[T]; lo, mi, hi: int) =
  if s[mi - 1] <= s[mi]: return
  var t = newSeq[T](hi - lo)
  var i = lo
  var j = mi
  for k in 0 ..< hi - lo:
    if i < mi and (j == hi or s[i] <= s[j]):
      t[k] = s[i]
      inc i
    else:
      t[k] = s[j]
      inc j
  for k in 0 ..< hi - lo:
    s[lo + k] = t[k]


proc fibonacciSort[T](s: var openArray[T]) =
  let n = s.len
  if n <= 1: return
  var
    lo = -1
    mi =  0
    hi =  1
  var v = @[lo, mi, hi]
  while not (mi == 0 and hi == n):
    if hi == n or (mi != 0 and 2 * (hi - mi) >= mi - lo):
      merge(s, lo, mi, hi)
      v.delete(v.len - 2)
      styledEcho(fgMagenta, "xmerge: ", resetStyle, $v)
    else:
      v.add(hi + 1)
      styledEcho(fgRed, "add ", align($(hi+1), 2), ": ",
      resetStyle, $v)
    (lo, mi, hi) = (v[^3], v[^2], v[^1])


proc fibonacciSortAlt[T](s: var openArray[T]) =
  let n = s.len
  if n <= 1: return
  var
    lo = -1
    mi =  0
    hi =  1
  var v = @[lo, mi, hi]
  while hi != n:
    v.add(hi + 1)
    styledEcho(fgRed, "add ", align($(hi+1), 2), ": ",
    resetStyle, $v)
    (lo, mi, hi) = (v[^3], v[^2], v[^1])
    while mi != 0 and 2 * (hi - mi) >= mi - lo:
      merge(s, lo, mi, hi)
      v.delete(v.len - 2)
      styledEcho(fgGreen, "cmerge: ", resetStyle, $v)
      (lo, mi, hi) = (v[^3], v[^2], v[^1])
  while mi != 0:
    merge(s, lo, mi, hi)
    v.delete(v.len - 2)
    styledEcho(fgCyan, "umerge: ", resetStyle, $v)
    (lo, mi, hi) = (v[^3], v[^2], v[^1])

#[
randomize()
let n = rand(1 .. 20)
var s = newSeq[int](n)
for i in 0 ..< n: s[i] = i
shuffle(s)
echo s
fibonacciSort(s)
echo s
]#